package
{
	import mx.core.FlexSprite;
	import org.flixel.*;
	import com.newgrounds.*;
	import weapons.*;
	public class PlayState extends FlxState
	{
		private  var background:FlxSprite;
		private var treasure:FlxSprite;
		private var map:FlxTilemap;
		public static var player:Player;
		private var trophy:FlxSprite;
		private var shieldorc:FlxSprite;
		private var platforms:FlxGroup;
		private var gotKey:Boolean;
		private var enemies:FlxGroup;
		private var slimes:Slimes;
		private var slime:Slime;
		private var inventory:Inventory;
		
		//*************************************************
		private static var bullets:Bullets;
		private static var bullet:Bullet;
		//доделать?
		
		
		override public function create():void
		{
			//STARTING THE GAME...
			
			FlxG.flash(0);
			FlxG.playMusic(Sources.Mp3Soundtrack, 0.7);
			FlxG.music.fadeIn(3);
			FlxG.framerate = 60;
			FlxG.flashFramerate = 60;
			
			// disable inventory
			Registry.InventoryUses = false;
			//Add some  junk  here
			background = new FlxSprite(0, 0, Sources.ImgBackground); //CREATE BACKGROUND
			background.scrollFactor = new FlxPoint();
			add(background); //ADDING BACKGROUND TO THE STAGE AND MAKING IT VISIBLE 
			
			map = new FlxTilemap(); //CREATING MAP
			map.loadMap(new Sources.TxtMap, Sources.ImgMap, 16, 16); //LOADING MAP
			add(map); //ADDING MAP 
			
			treasure = new FlxSprite(FlxG.width * 2 - 160, FlxG.height - 32, Sources.ImgTreasure);
			add(treasure);
			
			platforms = new FlxGroup;
			add(platforms);
			addPlatform(3, 2, 8, 2);
			addPlatform(12, 2, 17, 2);
			//Player
			player = new Player(); //CREATING PLAYER
			player.x = FlxG.width / 2;
			player.y = FlxG.height - 16; //SETTING POSITION OF THE PLAYER
			add(player); //ADDING PLAYER TO THE STAGE AND MAKING HIM VISIBLE
			
			//Enemies-  patrol mode & slimes - they  will find  path  themselves
			enemies = new FlxGroup;
			add(enemies);
			addEnemy(3, 13, 10, 13);
			addEnemy(11, 13, 16, 13);
			addEnemy(22, 13, 30, 13);
			
			
	
			//AGRH!
			addSlimes();
			add(slimes);
			//Camera
			FlxG.worldBounds=new FlxRect(0, 0, map.width, map.height);
			FlxG.camera.follow(player, FlxCamera.STYLE_PLATFORMER);
			FlxG.camera.setBounds(0, 0, map.width, map.height);
			
			trophy = new FlxSprite(FlxG.width / 2,16, Sources.ImgTrophy);
			add(trophy);
			//**************************
			Registry.map = map;
			bullets = new Bullets();
			add(bullets);
			//testing
			inventory = new Inventory;
			
			
		}
		private function addEnemy(startX:int,startY:int,endX:int,endY:int):void
		{
			var enemy:FlxSprite = new FlxSprite(startX * 16, startY * 16);
			
			 enemy.loadGraphic(Sources.ImgGolem, true, true, 16, 16);
			
			 
			enemies.add(enemy);
			
			enemy.acceleration.y = 300;
		
		
			enemy.addAnimation("walk", [0, 1], 10);
			enemy.play("walk");
			enemy.followPath(new FlxPath([new FlxPoint(startX * 16+8, startY * 16+8),new FlxPoint(endX * 16+8, endY * 16+8)]), 50, FlxObject.PATH_YOYO | FlxObject.PATH_HORIZONTAL_ONLY);
		}
		//Slime
		private function addSlimes():void
		{
		     slimes = new Slimes();
			 slimes.addSlime(31, 13);
			 slimes.addSlime(3, 3);
		}
		
		
		private function addPlatform(startX:int,startY:int,endX:int,endY:int):void
		{
			var platform:FlxSprite = new FlxSprite(startX * 16, startY * 16, Sources.ImgPlatform);
			platform.immovable = true;
			platforms.add(platform);
			platform.followPath(new FlxPath([new FlxPoint(startX * 16+8, startY * 16+8),new FlxPoint(endX * 16+8, endY * 16+8)]), 50, FlxObject.PATH_YOYO);
		
		}
		override public function update():void
		{
			FlxG.collide(player, map); //MAKE BOTH COLLIDE
			FlxG.overlap(player, trophy, gotTrophy);
			FlxG.collide(player, platforms);
			FlxG.collide(enemies, map);
			FlxG.collide(bullets, map,bulletCollided);
			FlxG.collide(slimes, map);
			FlxG.collide(enemies, player, enemyPlayer);
			FlxG.overlap(player, treasure, take);
			FlxG.collide(bullets, enemies,bulletEnemy);
		
			for (var j:int; j < enemies.length; j++)
			{
				if (enemies.members[j].velocity.x > 0)
				{
					enemies.members[j].facing = FlxObject.RIGHT;
				}
				else
				{
					enemies.members[j].facing = FlxObject.LEFT;
				}
			}
			shoot();
			inventorycheck();
			super.update();
		}
		//пульки
		private function bulletCollided(b:FlxSprite, a:FlxObject):void
		{
			bullets.remove(b, true);
			b = null;
		}
		private function bulletEnemy(b:FlxSprite, e:FlxObject):void
		{
			FlxG.flash(0xFFFFFFFF, 0.1);
			enemies.remove(e, true);
			e = null;
			bullets.remove(b, true);
			b = null;
		}
		private function gotShield(a:Player, b:FlxSprite):void
		{
			FlxG.play(Sources.Mp3Powerup, 0.7);
			remove(shieldorc);
			shieldorc = null
		}
		private function enemyPlayer(e:FlxSprite, p:Player):void
		{
		if (e.y > player.y)
			{
			FlxG.flash(0xFFFFFFFF, 0.1);
			FlxG.shake(0.01, 0.1);
			enemies.remove(e, true);
			}
			else
			{
				FlxG.flash();
				FlxG.switchState(new LostState);
				//damage player when i made  HP 
			}
		}
		
		
		private function gotTrophy(a:Player, b:FlxSprite):void
		{
			API.unlockMedal("Artefact");
			FlxG.flash();
			FlxG.play(Sources.Mp3Powerup, 0.7);
			remove(trophy);
			gotKey = true;
			trophy = null;
		}
		//Ataking functions  will be here
		private function shoot():void
		{if (FlxG.keys.justPressed('X'))
			{
				bullets.addBullet();
			}
		}	
		//if won
		private function win(p:Player, t:FlxSprite):void
		{
			FlxG.switchState(new WinState);
		}
		//Инвентарь
		private function inventorycheck():void	
			{
			if (FlxG.keys.justPressed('I'))
				{	if (Registry.InventoryUses==false)
					{	
					add(inventory);
					Registry.InventoryUses = true;
					} else
						{
						remove(inventory);
						Registry.InventoryUses = false;	
						}
				}	
			}
		//Treasure
		private function take(a:Player, b:FlxSprite):void
		{
			if (gotKey ==true)
			{
			remove(treasure);
			}
		
		}
	}
}