package  
{
	import org.flixel.*;

	public class Slime extends FlxSprite
	
	{
		public var isDying:Boolean = false;//  Uses in animation of death
		
		public function Slime(x:int,y:int) :void
		{
			super(x * 16, y * 16);
			
			loadGraphic(Sources.ImgSlime, true, true, 8, 8);
			acceleration.y = 50;
			addAnimation("crawl", [0, 1, 2, 0], 5);
			play("crawl");
			
		}
		override public function update():void
		{
			super.update();
			
			//	Check the tiles on the left / right of it
			
			var tx:int = int(x/16);
			var ty:int = int(y/16);
			
			if (facing == FlxObject.LEFT)
			{
				//	0 is the Collide Index of our Tilemap (which sadly isn't exposed in Flixel 2.5, so is hard-coded here. Not ideal I appreciate)
				if (Registry.map.getTile(tx - 1, ty) >0)
				{
					turnAround();
					return;
				}
			}
			else
			{
				//	0 is the Collide Index of our Tilemap (which sadly isn't exposed in Flixel 2.5, so is hard-coded here. Not ideal I appreciate)
				if (Registry.map.getTile(tx + 1, ty) >0)
				{
					turnAround();
					return;
				}
			}
			
			//	Check the tiles below it
			
			if (isTouching(FlxObject.FLOOR) == false && isDying == false)
			{
				turnAround();
			}
			
		}
		private function turnAround():void
		{
			if (facing == FlxObject.RIGHT)
			{
				facing = FlxObject.LEFT;
				
				velocity.x = -30;
			}
			else
			{
				facing = FlxObject.RIGHT;
				
				velocity.x = 30;
			}
		}
		
	}

}